## antpm 1.24

=== src/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8-dos -*-
CMAKE_MINIMUM_REQUIRED(VERSION 3.14.2)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

option(macos_native "don't look for non apple system paths" OFF) # https://gitlab.kitware.com/cmake/cmake/-/issues/21918
if(macos_native)
  if(APPLE)
    set(CMAKE_IGNORE_PATH)
    # Fink installs in /sw, and MacPort in /opt/local and Brew in /usr/local (x86-64) and /opt/homebrew (arm64)
    foreach(_prefix /sw /opt/local /usr/local /opt/homebrew)
      list(APPEND CMAKE_IGNORE_PATH ${_prefix}/bin ${_prefix}/include ${_prefix}/lib)
    endforeach()
  else()
    message(STATUS "Option 'macos_native' is only for MacOS systems. Ignoring it.")
  endif()
endif()

PROJECT(antpm C CXX)
SET(CMAKE_CXX_STANDARD 17)
SET(CXX_STANDARD_REQUIRED ON)

OPTION(USE_COVERAGE "use gcov" FALSE)
OPTION(USE_BOOST_TEST "use boost::test" FALSE)
OPTION(USE_BOOST_STATIC_LINK "link statically against boost" TRUE)
IF(MSVC OR APPLE)
  OPTION(USE_GANT "build gant" FALSE)
ELSE()
  OPTION(USE_GANT "build gant" TRUE)
ENDIF()

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

# Set a default build type for single-configuration
# CMake generators if no build type is set.
IF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE Debug)
ENDIF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
MESSAGE(STATUS "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "CMAKE_CONFIGURATION_TYPES=${CMAKE_CONFIGURATION_TYPES}")

set(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} -DNDEBUG=1")
set(CMAKE_C_FLAGS_RELEASE          "${CMAKE_C_FLAGS_RELEASE} -DNDEBUG=1")

IF(MSVC)
    SET(LIBUSB_ROOT "C:/vcpkg/installed/x64-windows" CACHE PATH "Libusb PATH")
    SET(BOOST_ROOT "c:/local/boost_1_87_0"  CACHE PATH "Boost PATH" )

  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MD")
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
  ADD_DEFINITIONS(-D_WIN32_WINNT=0x0500)
ENDIF()

IF(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS} -Wall -Werror")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -g")
  SET(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} -O2")
  set(CMAKE_CXX_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3 -ggdb3")
  set(CMAKE_C_FLAGS                  "${CMAKE_C_FLAGS} -std=c99 -pedantic -Wextra -Wall")
  set(CMAKE_C_FLAGS_DEBUG            "${CMAKE_C_FLAGS_DEBUG} -g3 -ggdb3")

  IF(USE_COVERAGE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    set(CMAKE_EXE_LINKER_FLAGS
      "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  ENDIF()
ENDIF()

IF(MSVC)
  INCLUDE(Findlibusb-1.0)
  IF(NOT LIBUSB_1_FOUND)
    MESSAGE(FATAL_ERROR "Could not find libusb-1.0")
  ENDIF()
ELSE()
  find_package(PkgConfig REQUIRED)
  pkg_check_modules(LIBUSB_1 REQUIRED libusb-1.0)
ENDIF()
MESSAGE(STATUS "LIBUSB_1: ${LIBUSB_1_INCLUDE_DIRS} ${LIBUSB_1_LIBRARY_DIRS} ${LIBUSB_1_LIBRARIES}")

IF(USE_BOOST_STATIC_LINK)
#    set(Boost_VERBOSE ON)
#    set(Boost_DEBUG ON)
  set(Boost_USE_STATIC_LIBS        ON)
  set(Boost_USE_STATIC_RUNTIME    OFF)
ELSE()
  set(Boost_USE_STATIC_LIBS        OFF)
  set(Boost_USE_STATIC_RUNTIME    OFF)
  ADD_DEFINITIONS(-DBOOST_TEST_MAIN)
  ADD_DEFINITIONS(-DBOOST_TEST_DYN_LINK)
ENDIF()
set(Boost_USE_MULTITHREADED      ON)
FIND_PACKAGE(Boost 1.41.0 COMPONENTS unit_test_framework program_options REQUIRED)
#IF(NOT Boost_FOUND)
#  MESSAGE(FATAL_ERROR "Boost not found!")
#ENDIF()

IF(MSVC)
  ADD_DEFINITIONS(-D_CRT_NONSTDC_NO_WARNINGS)
  #set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:libboost_date_time-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_thread-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_program_options-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_filesystem-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_system-vc90-mt-s-1_43.lib")
ENDIF()

FILE(READ "${PROJECT_SOURCE_DIR}/ANTPM_VERSION.inc" ANTPM_VERSION)
MESSAGE(STATUS "ANTPM_VERSION=\\\"${ANTPM_VERSION}\\\"")
ADD_DEFINITIONS(-DANTPM_VERSION=${ANTPM_VERSION})

IF(USE_BOOST_TEST)

  if(${VALGRIND_PREFIX})
    message(STATUS "Valgrind Prefix: ${VALGRIND_PREFIX}")
  endif()
  find_program(VALGRIND_PROGRAM NAMES valgrind PATH /usr/bin /usr/local/bin ${VALGRIND_PREFIX}/bin)
  IF(VALGRIND_PROGRAM)
    message(STATUS "Found Valgrind: ${VALGRIND_PROGRAM}")
    SET(MEMORYCHECK_COMMAND:FILEPATH=${VALGRIND_PROGRAM})
    # You can add additional options by specifying MEMORYCHECK_COMMAND_OPTIONS and MEMORYCHECK_SUPPRESSIONS_FILE. 
  ENDIF()

  enable_testing()
ENDIF()
  
SET(SRCS
  antdefs.hpp antdefs.cpp
  w_inttypes.h w_stdint.h stdintfwd.hpp
  common.hpp common.cpp
  AntMessage.hpp AntMessage.cpp
  AntChannel.hpp   AntChannel.cpp
  AntMessenger.hpp AntMessenger.cpp
  SerialUsb.hpp SerialUsb.cpp
  AntFr310XT.hpp AntFr310XT.cpp
  lqueue.hpp
  Serial.hpp Serial.cpp

  FIT.hpp FIT.cpp
  GPX.hpp GPX.cpp
  GarminConvert.hpp GarminConvert.cpp
  GarminPacketIntf.hpp GarminPacketIntf.cpp

  DeviceSettings.hpp DeviceSettings.cpp

  Log.hpp
  LazySingleton.hpp

  ANTPM_VERSION.inc
)
IF(NOT WIN32)
  SET(SRCS
      ${SRCS}
      SerialTty.hpp SerialTty.cpp
      )
  SET(MY_ANTPM_LIBRARIES "pthread")
  IF(NOT APPLE)
    SET(MY_ANTPM_LIBRARIES "${MY_ANTPM_LIBRARIES};rt")
  ENDIF()
  IF(APPLE)
      SET(LIBUSB_1_LIBRARIES ${pkgcfg_lib_LIBUSB_1_usb-1.0})
  ENDIF()
ENDIF()


ADD_LIBRARY(antpm
  ${SRCS}
  )
TARGET_INCLUDE_DIRECTORIES(antpm PUBLIC .)
TARGET_INCLUDE_DIRECTORIES(antpm PRIVATE ${LIBUSB_1_INCLUDE_DIRS})
TARGET_INCLUDE_DIRECTORIES(antpm PRIVATE ${Boost_INCLUDE_DIR})
TARGET_LINK_DIRECTORIES(antpm
    PRIVATE ${LIBUSB_1_LIBRARY_DIRS}
    )
TARGET_LINK_LIBRARIES(antpm
  ${LIBUSB_1_LIBRARIES}
  ${MY_ANTPM_LIBRARIES}
)

ADD_EXECUTABLE(antpm-usbmon2ant
  antpm-usbmon2ant.cpp
)
TARGET_LINK_LIBRARIES(antpm-usbmon2ant
  antpm
  Boost::program_options
)
INSTALL(TARGETS antpm-usbmon2ant RUNTIME DESTINATION bin)


ADD_EXECUTABLE(antpm-downloader
  antpm-downloader.cpp
)
TARGET_LINK_LIBRARIES(antpm-downloader
  antpm
  Boost::program_options
)
INSTALL(TARGETS antpm-downloader RUNTIME DESTINATION bin)


ADD_EXECUTABLE(antpm-fit2gpx
  antpm-fit2gpx.cpp
)
TARGET_LINK_LIBRARIES(antpm-fit2gpx
  antpm
  Boost::program_options
)
INSTALL(TARGETS antpm-fit2gpx RUNTIME DESTINATION bin)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

IF(USE_GANT AND NOT WIN32)
  ADD_SUBDIRECTORY(gant)
ENDIF()


IF(USE_BOOST_TEST)
  ADD_SUBDIRECTORY(tests)
ENDIF()

=== src/gant/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8-dos -*-


FIND_PACKAGE(LibXml2)
IF(NOT LIBXML2_FOUND)
  MESSAGE(FATAL_ERROR "libxml2 not found!")
ENDIF()

INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(${LIBXML2_INCLUDE_DIR})

SET(SRCS
  antdefs.h
  antlib.c
  antlib.h
  gant.c
)

ADD_EXECUTABLE(gant
  ${SRCS}
)
TARGET_LINK_LIBRARIES(gant
  m
  pthread
  ${LIBXML2_LIBRARIES}
)
INSTALL(TARGETS gant RUNTIME DESTINATION bin)

IF(USE_BOOST_TEST)
  ADD_SUBDIRECTORY(tests)
ENDIF()

=== src/tests/CMakeLists.txt ===
ADD_DEFINITIONS(-DUSE_BOOST_TEST=1)
ADD_DEFINITIONS(-DTEST_ROOT=\"${CMAKE_CURRENT_SOURCE_DIR}\")
MESSAGE(STATUS "TEST_ROOT=\"${CMAKE_CURRENT_SOURCE_DIR}\"")

ADD_EXECUTABLE(testDeviceSettings
  testDeviceSettings.cpp
)
TARGET_LINK_LIBRARIES(testDeviceSettings
  antpm
  Boost::program_options
  Boost::unit_test_framework
)

ADD_EXECUTABLE(testDateTime
  testDateTime.cpp
)
TARGET_LINK_LIBRARIES(testDateTime
  antpm
  Boost::program_options
  Boost::unit_test_framework
)


ADD_EXECUTABLE(sm1
  sm1.cpp
)
TARGET_LINK_LIBRARIES(sm1
  antpm
  Boost::unit_test_framework
)

ADD_EXECUTABLE(lq1
  lq1.cpp
)
TARGET_LINK_LIBRARIES(lq1
  antpm
  Boost::unit_test_framework
)


IF(VALGRIND_PROGRAM)
  function(ADD_MY_TEST name binary)
    #set(memcheck_command "${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS}")
    #separate_arguments(memcheck_command)
    add_test(${name} ${binary} ${ARGN})
    add_test(memcheck_${name} ${VALGRIND_PROGRAM} --leak-check=full ./${binary} ${ARGN})
  endfunction()

  function(set_memcheck_test_properties name)
    set_tests_properties(${name} ${ARGN})
    set_tests_properties(memcheck_${name} ${ARGN})
  endfunction()
ELSE()
  function(ADD_MY_TEST name binary)
    add_test(${name} ${binary} ${ARGN})
  endfunction()
ENDIF()

ADD_MY_TEST(testDeviceSettings1 testDeviceSettings)

ADD_MY_TEST(testDateTime1 testDateTime)

ADD_MY_TEST(testDeviceSettings2 testDeviceSettings --help)

ADD_MY_TEST(testDateTime2 testDateTime --help)

ADD_MY_TEST(testDownload ../antpm-downloader)

ADD_MY_TEST(testFit2Gpx ../antpm-fit2gpx)

ADD_MY_TEST(testUsbmon2AntParse  ../antpm-usbmon2ant --op parse  ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntDump   ../antpm-usbmon2ant --op dump   ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntUsbmon ../antpm-usbmon2ant --op usbmon ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntFilter ../antpm-usbmon2ant --op filter ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntCount  ../antpm-usbmon2ant --op count  ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)

ADD_MY_TEST(testLockedQueue lq1 --log_level=all)

ADD_MY_TEST(testStateMachineAsio sm1 --build_info --log_level=all --run_test=test_asio)
ADD_TEST(testStateMachine0 sm1 --build_info --log_level=all --run_test=test_serial0)
ADD_TEST(testStateMachine1 sm1 --build_info --log_level=all --run_test=test_serial1)
ADD_TEST(testStateMachine2 sm1 --build_info --log_level=all --run_test=test_serial2 -- ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)

=== src/gant/tests/CMakeLists.txt ===

IF(VALGRIND_PROGRAM)
  function(ADD_MY_TESTF name binary)
    #set(memcheck_command "${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS}")
    #separate_arguments(memcheck_command)
    add_test(NAME ${name} COMMAND ${binary} ${ARGN})
    set_tests_properties(${name} PROPERTIES WILL_FAIL TRUE)

    add_test(NAME memcheck_${name} COMMAND ${VALGRIND_PROGRAM} --leak-check=full ./${binary} ${ARGN})
    set_tests_properties(memcheck_${name} PROPERTIES WILL_FAIL TRUE)
  endfunction()

  function(set_memcheck_test_properties name)
    set_tests_properties(${name} ${ARGN})
    set_tests_properties(memcheck_${name} ${ARGN})
  endfunction()
ELSE()
  function(ADD_MY_TESTF name binary)
    add_test(${name} ${binary} ${ARGN})
    set_tests_properties(${name} PROPERTIES WILL_FAIL TRUE)
  endfunction()
ENDIF()

ADD_MY_TESTF(testGant ../gant)

=== debian/changelog ===
antpm (1.24-1) unstable; urgency=medium

  [ Kristóf Ralovich ]
  * new upstream release
    - replace most boost usage with C++ 17
  * debian: simple tests for executable from the binary package
  * debian: mark self tests as superficial
  * debian: only require valgrind for building on most common architectures
    (Closes: #1100495)
  * debian/control: restrict to architecture-is-little-endian
  * debian/rules: do not fail package building if tests don't succeed
    (Closes: #1100504)
  * debian: capture verbose logs of failing tests
  * debian/control: standards version 4.7.2

 -- Kristóf Ralovich <tade60@freemail.hu>  Sun, 30 Mar 2025 09:21:46 +0200

=== debian/control ===
Source: antpm
Priority: optional
Section: utils
Maintainer: Kristóf Ralovich <tade60@freemail.hu>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 devscripts,
 libboost-program-options-dev,
 libboost-test-dev,
 libusb-1.0-0-dev,
 libxml2-dev,
 pkgconf,
 valgrind-if-available,
 architecture-is-little-endian
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/debian/antpm.git
Vcs-Browser: https://salsa.debian.org/debian/antpm
Homepage: https://github.com/ralovich/antpm

Package: antpm
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ANT+ information retrieval client for Garmin GPS products
 This software uses the Garmin ANT+ proprietary USB keys and
 communication protocol to retrieve information (such as GPS traces)
 from some Garmin Forerunner watches such as Forerunner 405 and 310XT.
 .
 The underlying ANT+minus implements the ANT/ANT+/ANT-FS protocols to
 provide these tools: garmin-ant-downloader, antpm-downloader,
 antpm-fit2gpx, and antpm-usbmon2ant.
 .
 ANT+minus is a userspace implementation of a wire protocol similar
 to the ANT/ANT+/ANT-FS protocols. The goal is to be able to communicate
 with any ANT capable device in order to e.g. retrieve sports tracks. The
 C++ implementation is currently available under both Linux and win.
 Communication with watches other than the 310XT might work, but are
 untested. Please report your experience to help improving the software.
 .
 The software was originally named "gant" but renamed when packaged
 to avoid confusion with existing Java software.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
#   CFLAGS += -O2
# endif

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

NUMCPUS=$(shell grep -c '^processor' /proc/cpuinfo)
ifeq ($(NUMCPUS),0)
		NUMCPUS=1
endif
ifeq ($(NUMCPUS),)
		NUMCPUS=1
endif

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=src --builddirectory=cmake-build -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_C_FLAGS="${CMAKE_C_FLAGS} $(CFLAGS)" -DCMAKE_CXX_FLAGS="${CMAKE_CXX_FLAGS} $(CXXFLAGS)" -DUSE_BOOST_TEST=TRUE

override_dh_auto_build:
	cd cmake-build && $(MAKE) -j$(NUMCPUS) VERBOSE=true

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd cmake-build && ctest -N && ctest -j$(NUMCPUS) --rerun-failed --output-on-failure || true
endif

override_dh_auto_clean:
	dh_auto_clean
	$(RM) src/tests/config_tmp.ini
	$(RM) -r cmake-build

DESTDIR=../debian/antpm/
override_dh_install:
	cd cmake-build && $(MAKE) install DESTDIR=$(DESTDIR)
	mv debian/antpm/usr/bin/gant debian/antpm/usr/bin/antpm-garmin-ant-downloader
	cp scripts/80-ant-stick.rules debian/antpm.udev
	dh_installudev
	dh_install

=== debian/tests/control ===
Test-Command: antpm-downloader -V
Depends: antpm
Restrictions: superficial

Tests: run-help
Depends: antpm
Restrictions: superficial
